#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCVirtualPort.h"
#import "QCIndexPort.h"
#import "QCStructurePort.h"
#import "QCStructure.h"
			
static const unsigned int kStructureRecordBack = (1<<0);
static const unsigned int kStructureRecordLoop = (1<<1);
static const unsigned int kStructureRecordSignal = (1<<2);
static const unsigned int kStructureRecordBAO = (1<<3);

@interface StructureRecordAdv : QCPatch
{
    QCVirtualPort	*inputVirtual;
	QCBooleanPort	*inputGate;
	QCBooleanPort	*inputClear;
	QCBooleanPort	*inputClearOnGate;
	QCBooleanPort	*inputClearWithObject;
	QCIndexPort		*inputMode;
	QCIndexPort		*inputMaxSamples;
	
    QCStructurePort	*outputStruct;
	QCIndexPort		*outputIndex;

	// for performance, buffer should eventually become a simple C id* array.
	NSMutableArray	*buffer;
	QCStructure		*structure;
	unsigned int	index;	/* our working index in the buffer */
	unsigned int	recorded;	/* record counter for stop modes */
	BOOL			oldGateValue;
	BOOL			triggered;	/* used in Buffer-At-Once mode, true when latched */
	BOOL			cgMode;	/* CoreGraphics Mode, used to work around Apple's broken iSight driver */
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;
- (NSDictionary*)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;

- (NSDictionary*)state;
- (BOOL)setState:(NSDictionary*)state;

- (void)toggleCGMode;
- (BOOL)cgMode;
@end
